Index: IMGUI/imgui.cpp
===================================================================
--- IMGUI/imgui.cpp	(revision c58ebc3899e898504313cf42b9c1c05170b13f8f)
+++ IMGUI/imgui.cpp	(revision e66fd66b98dfb2d3f0f1af0833f4b2957f60d166)
@@ -13034,61 +9450,66 @@
 bool ImGui::SetDragDropPayload(const char* type, const void* data, size_t data_size, ImGuiCond cond)
 {
-   ImGuiContext& g = *GImGui;
-   ImGuiPayload& payload = g.DragDropPayload;
-   if (cond == 0)
-      cond = ImGuiCond_Always;
-
-   IM_ASSERT(type != NULL);
-   IM_ASSERT(strlen(type) < IM_ARRAYSIZE(payload.DataType) && "Payload type can be at most 12 characters long");
-   IM_ASSERT((data != NULL && data_size > 0) || (data == NULL && data_size == 0));
-   IM_ASSERT(cond == ImGuiCond_Always || cond == ImGuiCond_Once);
-   IM_ASSERT(payload.SourceId != 0);                               // Not called between BeginDragDropSource() and EndDragDropSource()
-
-   if (cond == ImGuiCond_Always || payload.DataFrameCount == -1)
-   {
-      // Copy payload
-      ImStrncpy(payload.DataType, type, IM_ARRAYSIZE(payload.DataType));
-      g.DragDropPayloadBufHeap.resize(0);
-      if (data_size > sizeof(g.DragDropPayloadBufLocal))
-      {
-         // Store in heap
-         g.DragDropPayloadBufHeap.resize((int)data_size);
-         payload.Data = g.DragDropPayloadBufHeap.Data;
-         memcpy(payload.Data, data, data_size);
-      }
-      else if (data_size > 0)
-      {
-         // Store locally
-         memset(&g.DragDropPayloadBufLocal, 0, sizeof(g.DragDropPayloadBufLocal));
-         payload.Data = g.DragDropPayloadBufLocal;
-         memcpy(payload.Data, data, data_size);
-      }
-      else
-      {
-         payload.Data = NULL;
-      }
-      payload.DataSize = (int)data_size;
-   }
-   payload.DataFrameCount = g.FrameCount;
-
-   return (g.DragDropAcceptFrameCount == g.FrameCount) || (g.DragDropAcceptFrameCount == g.FrameCount - 1);
+    ImGuiContext& g = *GImGui;
+    ImGuiPayload& payload = g.DragDropPayload;
+    if (cond == 0)
+        cond = ImGuiCond_Always;
+
+    IM_ASSERT(type != NULL);
+    IM_ASSERT(strlen(type) < IM_ARRAYSIZE(payload.DataType) && "Payload type can be at most 32 characters long");
+    IM_ASSERT((data != NULL && data_size > 0) || (data == NULL && data_size == 0));
+    IM_ASSERT(cond == ImGuiCond_Always || cond == ImGuiCond_Once);
+    IM_ASSERT(payload.SourceId != 0);                               // Not called between BeginDragDropSource() and EndDragDropSource()
+
+    if (cond == ImGuiCond_Always || payload.DataFrameCount == -1)
+    {
+        // Copy payload
+        ImStrncpy(payload.DataType, type, IM_ARRAYSIZE(payload.DataType));
+        g.DragDropPayloadBufHeap.resize(0);
+        if (data_size > sizeof(g.DragDropPayloadBufLocal))
+        {
+            // Store in heap
+            g.DragDropPayloadBufHeap.resize((int)data_size);
+            payload.Data = g.DragDropPayloadBufHeap.Data;
+            memcpy(payload.Data, data, data_size);
+        }
+        else if (data_size > 0)
+        {
+            // Store locally
+            memset(&g.DragDropPayloadBufLocal, 0, sizeof(g.DragDropPayloadBufLocal));
+            payload.Data = g.DragDropPayloadBufLocal;
+            memcpy(payload.Data, data, data_size);
+        }
+        else
+        {
+            payload.Data = NULL;
+        }
+        payload.DataSize = (int)data_size;
+    }
+    payload.DataFrameCount = g.FrameCount;
+
+    return (g.DragDropAcceptFrameCount == g.FrameCount) || (g.DragDropAcceptFrameCount == g.FrameCount - 1);
 }
 
 bool ImGui::BeginDragDropTargetCustom(const ImRect& bb, ImGuiID id)
 {
-   ImGuiContext& g = *GImGui;
-   if (!g.DragDropActive)
-      return false;
-
-   ImGuiWindow* window = g.CurrentWindow;
-   if (g.HoveredWindow == NULL || window->RootWindow != g.HoveredWindow->RootWindow)
-      return false;
-   IM_ASSERT(id != 0);
-   if (!IsMouseHoveringRect(bb.Min, bb.Max) || (id == g.DragDropPayload.SourceId))
-      return false;
-
-   g.DragDropTargetRect = bb;
-   g.DragDropTargetId = id;
-   return true;
+    ImGuiContext& g = *GImGui;
+    if (!g.DragDropActive)
+        return false;
+
+    ImGuiWindow* window = g.CurrentWindow;
+    ImGuiWindow* hovered_window = g.HoveredWindowUnderMovingWindow;
+    if (hovered_window == NULL || window->RootWindow != hovered_window->RootWindow)
+        return false;
+    IM_ASSERT(id != 0);
+    if (!IsMouseHoveringRect(bb.Min, bb.Max) || (id == g.DragDropPayload.SourceId))
+        return false;
+    if (window->SkipItems)
+        return false;
+
+    IM_ASSERT(g.DragDropWithinTarget == false);
+    g.DragDropTargetRect = bb;
+    g.DragDropTargetId = id;
+    g.DragDropWithinTarget = true;
+    return true;
 }
 
@@ -13099,72 +9520,82 @@
 bool ImGui::BeginDragDropTarget()
 {
-   ImGuiContext& g = *GImGui;
-   if (!g.DragDropActive)
-      return false;
-
-   ImGuiWindow* window = g.CurrentWindow;
-   if (!(window->DC.LastItemStatusFlags & ImGuiItemStatusFlags_HoveredRect))
-      return false;
-   if (g.HoveredWindow == NULL || window->RootWindow != g.HoveredWindow->RootWindow)
-      return false;
-
-   const ImRect& display_rect = (window->DC.LastItemStatusFlags & ImGuiItemStatusFlags_HasDisplayRect) ? window->DC.LastItemDisplayRect : window->DC.LastItemRect;
-   ImGuiID id = window->DC.LastItemId;
-   if (id == 0)
-      id = window->GetIDFromRectangle(display_rect);
-   if (g.DragDropPayload.SourceId == id)
-      return false;
-
-   g.DragDropTargetRect = display_rect;
-   g.DragDropTargetId = id;
-   return true;
+    ImGuiContext& g = *GImGui;
+    if (!g.DragDropActive)
+        return false;
+
+    ImGuiWindow* window = g.CurrentWindow;
+    if (!(window->DC.LastItemStatusFlags & ImGuiItemStatusFlags_HoveredRect))
+        return false;
+    ImGuiWindow* hovered_window = g.HoveredWindowUnderMovingWindow;
+    if (hovered_window == NULL || window->RootWindow != hovered_window->RootWindow)
+        return false;
+
+    const ImRect& display_rect = (window->DC.LastItemStatusFlags & ImGuiItemStatusFlags_HasDisplayRect) ? window->DC.LastItemDisplayRect : window->DC.LastItemRect;
+    ImGuiID id = window->DC.LastItemId;
+    if (id == 0)
+        id = window->GetIDFromRectangle(display_rect);
+    if (g.DragDropPayload.SourceId == id)
+        return false;
+
+    IM_ASSERT(g.DragDropWithinTarget == false);
+    g.DragDropTargetRect = display_rect;
+    g.DragDropTargetId = id;
+    g.DragDropWithinTarget = true;
+    return true;
 }
 
 bool ImGui::IsDragDropPayloadBeingAccepted()
 {
-   ImGuiContext& g = *GImGui;
-   return g.DragDropActive && g.DragDropAcceptIdPrev != 0;
+    ImGuiContext& g = *GImGui;
+    return g.DragDropActive && g.DragDropAcceptIdPrev != 0;
 }
 
 const ImGuiPayload* ImGui::AcceptDragDropPayload(const char* type, ImGuiDragDropFlags flags)
 {
-   ImGuiContext& g = *GImGui;
-   ImGuiWindow* window = g.CurrentWindow;
-   ImGuiPayload& payload = g.DragDropPayload;
-   IM_ASSERT(g.DragDropActive);                        // Not called between BeginDragDropTarget() and EndDragDropTarget() ?
-   IM_ASSERT(payload.DataFrameCount != -1);            // Forgot to call EndDragDropTarget() ? 
-   if (type != NULL && !payload.IsDataType(type))
-      return NULL;
-
-   // Accept smallest drag target bounding box, this allows us to nest drag targets conveniently without ordering constraints.
-   // NB: We currently accept NULL id as target. However, overlapping targets requires a unique ID to function!
-   const bool was_accepted_previously = (g.DragDropAcceptIdPrev == g.DragDropTargetId);
-   ImRect r = g.DragDropTargetRect;
-   float r_surface = r.GetWidth() * r.GetHeight();
-   if (r_surface < g.DragDropAcceptIdCurrRectSurface)
-   {
-      g.DragDropAcceptIdCurr = g.DragDropTargetId;
-      g.DragDropAcceptIdCurrRectSurface = r_surface;
-   }
-
-   // Render default drop visuals
-   payload.Preview = was_accepted_previously;
-   flags |= (g.DragDropSourceFlags & ImGuiDragDropFlags_AcceptNoDrawDefaultRect); // Source can also inhibit the preview (useful for external sources that lives for 1 frame)
-   if (!(flags & ImGuiDragDropFlags_AcceptNoDrawDefaultRect) && payload.Preview)
-   {
-      // FIXME-DRAG: Settle on a proper default visuals for drop target.
-      r.Expand(3.5f);
-      bool push_clip_rect = !window->ClipRect.Contains(r);
-      if (push_clip_rect) window->DrawList->PushClipRectFullScreen();
-      window->DrawList->AddRect(r.Min, r.Max, GetColorU32(ImGuiCol_DragDropTarget), 0.0f, ~0, 2.0f);
-      if (push_clip_rect) window->DrawList->PopClipRect();
-   }
-
-   g.DragDropAcceptFrameCount = g.FrameCount;
-   payload.Delivery = was_accepted_previously && !IsMouseDown(g.DragDropMouseButton); // For extern drag sources affecting os window focus, it's easier to just test !IsMouseDown() instead of IsMouseReleased()
-   if (!payload.Delivery && !(flags & ImGuiDragDropFlags_AcceptBeforeDelivery))
-      return NULL;
-
-   return &payload;
+    ImGuiContext& g = *GImGui;
+    ImGuiWindow* window = g.CurrentWindow;
+    ImGuiPayload& payload = g.DragDropPayload;
+    IM_ASSERT(g.DragDropActive);                        // Not called between BeginDragDropTarget() and EndDragDropTarget() ?
+    IM_ASSERT(payload.DataFrameCount != -1);            // Forgot to call EndDragDropTarget() ?
+    if (type != NULL && !payload.IsDataType(type))
+        return NULL;
+
+    // Accept smallest drag target bounding box, this allows us to nest drag targets conveniently without ordering constraints.
+    // NB: We currently accept NULL id as target. However, overlapping targets requires a unique ID to function!
+    const bool was_accepted_previously = (g.DragDropAcceptIdPrev == g.DragDropTargetId);
+    ImRect r = g.DragDropTargetRect;
+    float r_surface = r.GetWidth() * r.GetHeight();
+    if (r_surface < g.DragDropAcceptIdCurrRectSurface)
+    {
+        g.DragDropAcceptFlags = flags;
+        g.DragDropAcceptIdCurr = g.DragDropTargetId;
+        g.DragDropAcceptIdCurrRectSurface = r_surface;
+    }
+
+    // Render default drop visuals
+    payload.Preview = was_accepted_previously;
+    flags |= (g.DragDropSourceFlags & ImGuiDragDropFlags_AcceptNoDrawDefaultRect); // Source can also inhibit the preview (useful for external sources that lives for 1 frame)
+    if (!(flags & ImGuiDragDropFlags_AcceptNoDrawDefaultRect) && payload.Preview)
+    {
+        // FIXME-DRAG: Settle on a proper default visuals for drop target.
+        r.Expand(3.5f);
+        bool push_clip_rect = !window->ClipRect.Contains(r);
+        if (push_clip_rect) window->DrawList->PushClipRect(r.Min - ImVec2(1, 1), r.Max + ImVec2(1, 1));
+        window->DrawList->AddRect(r.Min, r.Max, GetColorU32(ImGuiCol_DragDropTarget), 0.0f, ~0, 2.0f);
+        if (push_clip_rect) window->DrawList->PopClipRect();
+    }
+
+    g.DragDropAcceptFrameCount = g.FrameCount;
+    payload.Delivery = was_accepted_previously && !IsMouseDown(g.DragDropMouseButton); // For extern drag sources affecting os window focus, it's easier to just test !IsMouseDown() instead of IsMouseReleased()
+    if (!payload.Delivery && !(flags & ImGuiDragDropFlags_AcceptBeforeDelivery))
+        return NULL;
+
+    return &payload;
+}
+
+const ImGuiPayload* ImGui::GetDragDropPayload()
+{
+    ImGuiContext& g = *GImGui;
+    return g.DragDropActive ? &g.DragDropPayload : NULL;
 }
 
